/*
PROCEDURY potrzebne do OBsugi MT8888; ZAGEARKA I INNE
Radosaw Rochowski 10.01.2009


*/

#define SET_RD_MT PORTC |= _BV(3);   	// Deklaracja pinu RD ukadu MT8888
#define CLR_RD_MT PORTC &= ~_BV(3); 
#define SET_RS0_MT PORTC |= _BV(2);   	// Deklaracja pinu RS0 ukadu MT8888
#define CLR_RS0_MT PORTC &= ~_BV(2);
#define SET_WR_MT PORTC |= _BV(1);   	// Deklaracja pinu WR ukadu MT8888
#define CLR_WR_MT PORTC &= ~_BV(1);

void DANEX(char dane);
void EEPROM_write(unsigned int uiAddress, char ucData);
unsigned char EEPROM_read(unsigned int uiAddress);
void init_TIMER0();
void zegarynka(void);
void alarmowanie(void);
char alarmowanie2(void);
void inicMT8888(void);
void WRR(char dane);
char RDD(void);
void DANEX(char dane);
char zgloszenie(void);
void napisz(void);



//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^6
void EEPROM_write(unsigned int uiAddress, char ucData) 
{ 
/* Wait for completion of previous write */ 
while(EECR & (1<<EEWE)); 
/* Set up address and data registers */ 
EEAR = uiAddress; 
EEDR = ucData; 
/* Write logical one to EEMWE */ 
EECR |= (1<<EEMWE); 
/* Start eeprom write by setting EEWE */ 
EECR |= (1<<EEWE); 
} 

unsigned char EEPROM_read(unsigned int uiAddress)
{
/* Wait for completion of previous write */
while(EECR & (1<<EEWE));
/* Set up address register */
EEAR = uiAddress;
/* Start eeprom read by writing EERE */
EECR |= (1<<EERE);
/* Return data from data register */
return EEDR;
}


	


//TIMERY

// Ustawienia Timerw 

	void init_TIMER0()
	{
	//dla timero F osc = 11059200
	//prescaler 8
	//przerwanie co 20 ms 
	//tryb licznika podstawowy

	TCCR3B = 0b00000010;
	TCNT3H =0x94 ;	 // zaadowanie do licznika wartoci pocztkowej 
	TCNT3L =0x00 ;  
	ETIMSK = 0b00000100;


    TCCR1B = 0b01000001;
	//	TCCR1B ==|    INCN1      |     ICES1     | - | WGM13 | WGM12 | CS12 | CS11 | CS10 |
	//			 |Red. zakce  | Zbocze przech.| - |  Tryb pracy	 |      PRESCALER     |
	
	TCNT1H =0x86 ;	    	// zaadowanie do licznika wartoci pocztkowej 
	TCNT1L =0x97 ;   		//2,5 ms czuli 400 Hz
	TIMSK = 0b00100100;  	// odblokowanie przerwania OD LICZNIKA 1 OVERFLOW ORAZ PRZECHWYCENIE
	
	TIFR =TIFR | 0B00100000;//wyzerowanie znacznika przechwycenia

	}





//obsuga przrwania od przepenienia licznikw

	SIGNAL (SIG_OVERFLOW1) 
	{ 
	TCNT1H =0x86 ;	 // zaadowanie do licznika wartoci pocztkowej 
	TCNT1L =0x97 ;  
	czterystahz = 0;
	} 

	SIGNAL (SIG_INPUT_CAPTURE1)		// przerwanie od przechwycenia
	{
	TCNT1H =0x86 ;	 // zaadowanie do licznika wartoci pocztkowej 
	TCNT1L =0x97 ;  
	
	
	TIFR =TIFR | 0B00100000;			//wyzerowanie znacznika przechwycenia
	d_czas1 = ICR1L;	
	d_czas2 = ICR1H;
	d_czas2 = d_czas2 << 8;
	d_czas2 = d_czas2 + d_czas1;
	if (d_czas2 >= 0xD055) 	czterystahz = 1;	// sygna wikszy ni 2,2 ms
	else czterystahz = 0;

	}
	

	SIGNAL (SIG_OVERFLOW3) 
	{ 
	
	TCNT3H =0x94 ;	 // zaadowanie do licznika wartoci pocztkowej 
	TCNT3L =0x00 ;  
	zegar++; 		// zwikszenie o 1 zmiennej zegar 
  	aktywacja--;	//zmienna odpowiada za aktywacj alarmu  
 	hzon++;		//zmienna odpowiada za zliczanie czasu dla funkcji 400 HZ
	czas_wyj++;
	} 





void zegarynka(void)
	{
	zeg_temp=zegar+milisek;					//zapisanie wartoci zliczonej milisekund 
	zegar=0;								//wyzerowanie iloi milisekund

	while ( zeg_temp >= 50)		//zliczenie iloci sekund w zmiennej      1 imp = 20 ms
		{						//									     50 imp = 1sek
		d_sekundy++;
		zeg_temp=zeg_temp-50;
		};

	milisek=zeg_temp;			// pozostawienie milisekund do oblicze w kolejnym cyklu	

	while (d_sekundy >= 10)
		{
		s_sekundy++;
		d_sekundy=d_sekundy-10;
		};
	
	while ( s_sekundy >= 6)
		{
		d_minuty++;
		s_sekundy=s_sekundy-6;
		};
	
	while (d_minuty >= 10)
		{
		s_minuty++;
		d_minuty=d_minuty-10;
		};
	while (s_minuty >= 6)
		{
		d_godziny++;
		s_minuty=s_minuty-6;
		};
	while (d_godziny >= 10)
		{
		s_godziny++;
		d_godziny=d_godziny-10;
		};





	return;
	};


void alarmowanie(void)
	{
			
			//zerowanie zmiennych na wszelki wypadek
				temp_akt= 1500;
				temp_akt2=0;
				temp_akts=40;
				temp_aktd=40;
				temp_aktj=40;



	
		if (EEPROM_read(81)=='\0')			// fragment dla odczytania wartoci 
			{									// z pamieci eeprom wartoc aktywacja
			temp_akt =EEPROM_read(80)-48;
			goto derf;
			};
	
		if (EEPROM_read(82)=='\0')
			{
			temp_akt =EEPROM_read(81)-48;
			ak_smiec=EEPROM_read(80)-48;
			ak_smiec=ak_smiec*10;
			temp_akt=temp_akt+ak_smiec;
			goto derf;
			};

		if (EEPROM_read(83)=='\0')
			{
			temp_akt =EEPROM_read(82)-48;
			ak_smiec=EEPROM_read(81)-48;
			ak_smiec=ak_smiec*10;
			temp_akt=temp_akt+ak_smiec;
			ak_smiec=EEPROM_read(80)-48;
			ak_smiec=ak_smiec*100;
			temp_akt=temp_akt+ak_smiec;
			goto derf;	
			};

		derf:
		aktywacja = temp_akt * 50;		
	
	
	WriteTextXY(0,0,"Aktywacja alarmu");
	WriteTextXY(0,1,"za:       sek.  ");
	GotoXY(0,0);								//ustawienie pozycji kursora

	while (aktywacja != 0)
		{
		temp_akt2=0;			//zerowanie zmiennej do wywietlenia na LCD
		temp_akt=aktywacja /50;	//przeliczenie na sekundy
		
		while(temp_akt >= 100)
			{
			temp_akt2++;	
			temp_akt=temp_akt-100;
			};

			if(temp_akt2 != temp_akts)
				{
				temp_akts= temp_akt2; 
				GotoXY(4,1);
				LcdWrite(48+temp_akt2);
				};
		
	
		temp_akt2=0;			//zerowanie zmiennej do wywietlenia na LCD

		while (temp_akt >= 10)
			{
			temp_akt2++;	
			temp_akt=temp_akt-10;
			};
		if(temp_akt2 != temp_aktd)
				{
				temp_aktd= temp_akt2; 
				GotoXY(5,1);
				LcdWrite(48+temp_akt2);
				};
		if(temp_akt != temp_aktj)
				{
				temp_aktj= temp_akt; 
				GotoXY(6,1);
				LcdWrite(48+temp_akt);
				};

		if(temp_akt >= 11)
				{
				goto aktend;
				};
		
		
		GotoXY(0,1);	
		};


	GotoXY(0,0);								//ustawienie pozycji kursora
	WriteTextXY(0,0,"   A L A R M    ");
	WriteTextXY(0,1,"   UZBROJONY    ");
	GotoXY(0,0);								//ustawienie pozycji kursora
	
aktend:	
	l_menu_k=1;											//uruchomienie podmenu 3 dla "uptime"
//	l_menu_wys=0xfe;									//zezwolenie na wywietlenie opisu podmenu					
//	flagodb = 1;
	
	return;
	};

//*******************************************************************************************
//PROCEDURA odpowiada za opnienie alarmu w wypadku alarmu od otworzenia drzwi wejciowych

char alarmowanie2(void)
	{

		//zerowanie zmiennych na wszelki wypadek
				temp_akt= 1500;
				temp_akt2=0;
				temp_akts=40;
				temp_aktd=40;
				temp_aktj=40;	


	
		if (EEPROM_read(81)=='\0')			// fragment dla odczytania wartoci 
			{									// z pamieci eeprom wartoc aktywacja
			temp_akt =EEPROM_read(80)-48;
			goto derf2;
			};
	
		if (EEPROM_read(82)=='\0')
			{
			temp_akt =EEPROM_read(81)-48;
			ak_smiec=EEPROM_read(80)-48;
			ak_smiec=ak_smiec*10;
			temp_akt=temp_akt+ak_smiec;
			goto derf2;
			};

		if (EEPROM_read(83)=='\0')
			{
			temp_akt =EEPROM_read(82)-48;
			ak_smiec=EEPROM_read(81)-48;
			ak_smiec=ak_smiec*10;
			temp_akt=temp_akt+ak_smiec;
			ak_smiec=EEPROM_read(80)-48;
			ak_smiec=ak_smiec*100;
			temp_akt=temp_akt+ak_smiec;
			goto derf2;	
			};

		derf2:
		aktywacja = temp_akt * 50;		
	
	
	WriteTextXY(0,0,"  !!!!ALARM!!!! ");
	WriteTextXY(0,1,"za:       sek.  ");
	GotoXY(0,0);								//ustawienie pozycji kursora

	while (aktywacja != 0)
		{
		temp_akt2=0;			//zerowanie zmiennej do wywietlenia na LCD
		temp_akt=aktywacja /50;	//przeliczenie na sekundy
		
		while(temp_akt >= 100)
			{
			temp_akt2++;	
			temp_akt=temp_akt-100;
			};

			if(temp_akt2 != temp_akts)
				{
				temp_akts= temp_akt2; 
				GotoXY(4,1);
				LcdWrite(48+temp_akt2);
				};
		
	
		temp_akt2=0;			//zerowanie zmiennej do wywietlenia na LCD

		while (temp_akt >= 10)
			{
			temp_akt2++;	
			temp_akt=temp_akt-10;
			};
		if(temp_akt2 != temp_aktd)
				{
				temp_aktd= temp_akt2; 
				GotoXY(5,1);
				LcdWrite(48+temp_akt2);
				};
		if(temp_akt != temp_aktj)
				{
				temp_aktj= temp_akt; 
				GotoXY(6,1);
				LcdWrite(48+temp_akt);
				};

		if(temp_akt >= 11)
				{
				goto aktend2;
				};
		
			//	Sprawdzenie czy alarm nie zosta wyczony
			ak_smiec = PINE;
			ak_smiec = ak_smiec & 0b01000000; 
			if(ak_smiec == 0)
				{

				//zerowanie zmiennych na wszelki wypadek
			//	temp_akt= 1500;
			//	temp_akt2=0;
			//	temp_akts=40;
			//	temp_aktd=40;
			//	temp_aktj=40;
				return(0);		//	Alarm zosta wyczony
				};
		
			

		};


	
aktend2:	
	l_menu_k=1;											//uruchomienie podmenu 3 dla "uptime"
//	l_menu_wys=0xfe;									//zezwolenie na wywietlenie opisu podmenu					
//	flagodb = 1;
	
	return(1); // alarm nie zosta wyczony
	};



//*******************************************************************************************

//Inicjalizacja moduu MT8888



void inicMT8888(void)
	{
	SET_RS0_MT;
	RDD();
	WRR(0);
	WRR(0);
	WRR(8);
	WRR(0);
	RDD();
	CLR_RS0_MT;
	return;
	};


void WRR(char dane)
	{
	DDRC = 0xFE;
	asm("nop");
	asm("nop");
	asm("nop");
	SET_WR_MT;
	SET_RD_MT;
	DANEX(dane);
	asm("nop");
	CLR_WR_MT;
	asm("nop");
	asm("nop");
	asm("nop");
	SET_WR_MT;
	asm("nop");
	asm("nop");
	return;
	};

char RDD(void)
	{
	DDRC = 0b00001110;		//port MT8888 wejcia
	PORTC = 0b11110000;
	asm("nop");
	asm("nop");
	asm("nop");
	SET_WR_MT;
	SET_RD_MT;
	asm("nop");
	CLR_RD_MT;
	asm("nop");
	asm("nop");
	dane = PINC;
	SET_RD_MT;
	asm("nop");
	dane = dane & 0xF0;
	dane = dane >> 4;
	dane = dane & 0x0F;
	return (dane);
	};

void DANEX(char dane)
	{
	
	DDRC = 0b11111110;		//port MT8888 wyjcia
	asm("nop");
	asm("nop");
	asm("nop");
	dane=dane << 4;
	ak_smiec=PORTC & 0b00001111;
	ak_smiec=ak_smiec | dane;
	PORTC = ak_smiec;
	return;
	};

void nadajDTMF(char dane)
	{
		SET_RS0_MT;
		WRR(0b00001101);	//ustawienia rejestrw	
		WRR(0b00000001);
		CLR_RS0_MT;
		WRR(dane);	//Nadawanie cyfry5 
	return;
	};

//**************************************************************************************
	
//Detekja Sygnaw zgoszenia

char zgloszenie(void)
	{
    SET_RS0_MT;
	WRR(0b00001110);	//ustawienia rejestrw	
	WRR(0b00000001);	//wyczenie DTMF-u aktywacj CP		

	
	DDRB = 0b01100000;
	PORTB = PORTB & 0b10111111;	
	
	
	hzon = 0;	//Zerowanie ziennej czasu inkrementacja z przerwania


	while(czterystahz == 0)
		{
		if(hzon >= 250) return (5);//brak sygnau 400 Hz
		delay(100);
		WriteTextXY(0,0,"    SPRAWDZAM   ");	
	 	WriteTextXY(0,1,"    L I N I E   ");
		}; 	
	
	
	hzon = 0;	//Zerowanie ziennej czasu inkrementacja z przerwania
	while(czterystahz == 1)
		{
		if(hzon >= 75)return (1);// sygna cigly  1,5sek
		WriteTextXY(0,0,"    SPRAWDZAM   ");	
	 	WriteTextXY(0,1,"    L I N I E   ");
		}; 	
	

	if (hzon >= 40) return (2);	// Sygna oczekiwania na odebranie 0,8 sek
	if (hzon >= 20) return (3);		//Sygna zajtoci 0,4 sek
	if (hzon >= 2) return (4);		//sygna marszrutowania	40ms
	return(6);						//Nie rozpoznano sygna
	} 

//BCD
int BcdWys4 (unsigned int z1)
{

	x1 = x2 = x3 = x4 = 0;
	
	
	x1 = z1 & 0xF000;
	x1 = x1 >> 12;
	x1 = x1 + 0x30;
	
	x2 = z1 & 0x0F00;
	x2 = x2 >> 8;
	x2 = x2 + 0x30;	
	
	x3 = z1 & 0x00F0;
	x3 = x3 >> 4;
	x3 = x3 + 0x30;	 
	
	x4 = z1 & 0x000F;
	x4 = x4 + 0x30;	
	

	nadaj(x1);
	nadaj(x2);
	nadaj(x3);
	nadaj(x4);
return 0;
}


