void wybor(void);
void komunikacja_PC(void);
void nadaj_param(void);
void nadaj_eeprom(void);
void CLR_eeprom(void);

void komunikacja_PC(void)
{
if(flagodb == 1)											// informacja ze z portu rs232 odebrano znak
	{
	flagodb = 0;											//zerowanie flagi przyjcia znaku
	if(komenda == 13)										//opcje po wcisnieciu entera
		{
		buf_menu[l_menu_tab]='\0';							//zakoczenie wpisw w tablicy 
		l_menu_tab=0;		  								//wyzerowanie licznika tablicy
		nadaj(10);nadaj(13);								//cofnij do pocztku
		Bufor_rs_gotowy=1;									//zgoszenie tablicy jako gotowej
		}
	else
		{	
		nadaj (komenda); 										//usart2.h
		buf_menu[l_menu_tab]=komenda;							//dane z portu RS232 trafiaj do bufora
		if(l_menu_tab>=16) l_menu_tab=0;						//zabezpieczenie przed przekroczeniem zakrsu tabeli
		l_menu_tab++;
		};
	};
};


void wybor(void)
{
if (Bufor_rs_gotowy==1)
	{
	Bufor_rs_gotowy=0;

	if(l_menu_k==1)										//Gwne POD MENU
		{
		opis_k1();										//podmeenu.h
			if((strcmp(buf_menu,"1")) == 0)					// porwnanie znakw w tabeli ze zmienna
			{
			WriteTextXY(0,0,"  BOOT LOADER   ");	
			WriteTextXY(0,1,"                ");
			DebugSendString_P(PSTR("Nadaj plik aktualizacji  --nazwa.bin--   przy pomocy Xmodem"));
			nadaj(10); nadaj(13);
			asm("jmp 0xf000");							//skok do obszru pamici z bootloaderem
			};	
	
		if((strcmp(buf_menu,"2")) == 0)					// porwnanie znakw w tabeli ze zmienna
			{
			WDTCR=0b00001000;							//Uruchomienie WDT w celu resetu aplikacji
			};

		if((strcmp(buf_menu,"3")) == 0)					
			{
			if (parametry_pom==0)parametry_pom=1;
			else parametry_pom=0;
			};

		if((strcmp(buf_menu,"4")) == 0)		//Odczyt zapisanych danych EEPROM			
			{
			DebugSendString_P(PSTR("Odczyt danych z pamici:"));nadaj(10); nadaj(13);
			nadaj_eeprom();
			};

		if((strcmp(buf_menu,"5")) == 0)		//Ustawienie interwau zapisu danych do EEPROM			
			{
			DebugSendString_P(PSTR("Wprowadz dane interwalu czasowego w formacie (020) max 255 sekund"));
			nadaj(10); nadaj(13);
			l_menu_k=2;
			};
		if((strcmp(buf_menu,"6")) == 0)		//Czysczenie zawartosci EEPROM			
			{
			DebugSendString_P(PSTR("Trwa kasowanie pamici danych -czekaj"));
			CLR_eeprom();
			DebugSendString_P(PSTR("Gotowe"));
			};

		if((strcmp(buf_menu,"7")) == 0)		//Czysczenie zawartosci EEPROM			
			{
			DebugSendString_P(PSTR("Odczyt konfiguracji"));nadaj(10); nadaj(13);
			binbcd2(czas_eeprom_ustaw);
			DebugSendString_P(PSTR("Czas interwalu: "));nadaj(v1);nadaj(v2);nadaj(v3);nadaj(v4);nadaj(v5);nadaj(10); nadaj(13);
			};
		if((strcmp(buf_menu,"?")) == 0)					
			{
			opis_zezwalanie ();				//ustaw.h
			};
		}
	else{
		
		//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
		if(l_menu_k==2)				//odczyt danych z pc do ustawienia danych interwau
			{
			
			ak_smiec=0;
			ak_smiec=(buf_menu[0]-48)*100+(buf_menu[1]-48)*10+(buf_menu[2]-48);
			EEPROM_write(E_czas_eeprom,ak_smiec);
			czas_eeprom_ustaw=ak_smiec;
		
			l_menu_k=1;
		//	l_menu_wys=0xfe;									//zezwolenie na wywietlenie opisu podmenu
		//	flagodb = 1;
		//	komenda = 13;
			};
		};
	
	
	
	}
}


void nadaj_param(void)
{
if (parametry_pom==1)
	{
	if (del_sek==1)		// wysyanie danych co sekunde
		{
		del_sek=0;
		binbcd2 (Ibat);
		nadaj('I');nadaj('=');nadaj(v2);nadaj(',');nadaj(v3);nadaj(v4);nadaj(v5);nadaj(' ');

		binbcd2 (Ubat);
		nadaj('U');nadaj('=');nadaj(v2);nadaj(v3);nadaj(',');nadaj(v4);nadaj(v5); nadaj(' ');
	

		ak_smiec3=C_large2;
		binbcd2 (ak_smiec3);
		nadaj('C');nadaj('=');nadaj(v4);nadaj(v5);
		ak_smiec3=C_large;
		binbcd2 (ak_smiec3);
		nadaj(v2);nadaj(',');nadaj(v3);nadaj(v4);nadaj(v5);nadaj('A');nadaj('h');nadaj(' ');



		if(temp2>=248)		// temperatura ujemna
			{
			temp=(65536-(temp1+(temp2*256)))*10;
			temp_f=temp;
			temp=0;
			temp=temp_f/16;
			nadaj('-');
			}
		else			// temperatura dodatnia
			{
			temp=((temp1+(temp2*256))*10)/16;
			nadaj('+');	
			};
	 	binbcd2 (temp);
		nadaj(v2);nadaj(v3);nadaj(v4);nadaj(',');nadaj(v5);
		
		nadaj(10);nadaj(13);
		};
	};

};


void nadaj_eeprom(void)
{
	
	for (ink_eep=0;ink_eep<=bank_zakres;ink_eep=ink_eep+4)
		{

		ak_smiec=(EEPROM_read(bank_eeprom+ink_eep))+(256*(EEPROM_read(bank_eeprom+ink_eep+1)));	
		binbcd2(ak_smiec);
		nadaj('I');nadaj('=');nadaj(' ');nadaj(v1);nadaj(v2);nadaj(',');nadaj(v3);nadaj(v4);nadaj(v5);nadaj(' ');
		
		ak_smiec=(EEPROM_read(bank_eeprom+ink_eep+2))+(256*(EEPROM_read(bank_eeprom+ink_eep+3)));	
		binbcd2(ak_smiec);
		nadaj('U');nadaj('=');nadaj(' ');nadaj(v1);nadaj(v2);nadaj(v3);nadaj(',');nadaj(v4);nadaj(v5);nadaj(' ');
		nadaj(10);nadaj(13);
		};
};


void CLR_eeprom(void)
{
ak_smiec=0;
for (ink_eep=0;ink_eep<=2000;ink_eep++)
		{
		EEPROM_write((bank_eeprom+ink_eep),0);
		ak_smiec++;
		if(ak_smiec>=200)
			{
			ak_smiec=0;
			nadaj('*');
			};	
		};
}




