//#ifndef _USART2_H_
#define _USART2_H_

unsigned int  UART_SENDSTRING_RETURN_OK;
unsigned int DebugSendString_P (const char *strin);
char komenda;          //odebrana komenda
char flagodb;		   // flaga odbioru znaku z portu rs
void nadaj (char x);
void nadaj_tekst (char *S);
void init_USART();
SIGNAL(SIG_UART0_RECV);







unsigned int DebugSendString_P (const char *strin)
{
 char ch;
 const char *str = strin;

if(str==NULL) return(0);

	while ((ch=pgm_read_byte(str++))!=0x00)
	{
	 nadaj(ch);
	}
 return UART_SENDSTRING_RETURN_OK;
}

 

void nadaj (char x) 
{
	//if (bit_parzystosci == 1) UCSRB |= _BV(TXB8); else UCSRB &= ~_BV(TXB8);
	loop_until_bit_is_set(UCSR0A, UDRE);	// poczekaj na zakonczenie ewentualnego transferu
	UDR0 = x;
 	loop_until_bit_is_set(UCSR0A, UDRE);
	//return 0;
}


void nadaj_tekst (char *S)
{
	while (*S)								// ptla dziaa dotd,a napotkany zostanie znak koca acuch (/0)
	{
		nadaj(*S);						// wywietlenie pojedynczego znaku
		S++;
	}
}

void init_USART()
{
	// inicjacja UARTu
	UCSR0B = 0;				// wylacz usart - aytomatyczne czyszczenie buforow i flag
	loop_until_bit_is_set(UCSR1A, UDRE);	// poczekaj za zakonczenie ewentualnego transferu

	UCSR0A = 0x00;		// single Speed
	
	UCSR0C = 0x06;		// AsyncMode, no parity, 1 stop bit, 8-bit data
	//UCSRB = 0x0C;		// Transmitter enabled, datasize=9-bit
	
	UCSR0B = 0x98;		// RXD input_interrupt
	//UCSRB = 0x08;		// Transmitter enabled, datasize=8-bit (0x08)


	UBRR0H = 0x00;
	UBRR0L = 0x67;
	
}

  



SIGNAL(SIG_UART0_RECV) //Procedura obsugi odbiornika
{
    komenda = UDR0;
    flagodb = 1;
} 

//#endif

