
void menu_klaw_mat(void);
void zadania_klaw (void);

void Pomiar_temperatury(void);
int Pomiar_temperatury2(void);
void resecik (void);



void menu_klaw_mat(void)
	{
	if (l_menu_wys_mat!= 0xfe) return;
	l_menu_wys_mat=0xff;

	il_ekranow=5;  // to jest zmienna ktra pokazuje ekrany na LCD
	

	if (klaw_mat_menu==1)
		{
		WriteTextXY(0,0,"Ladowanie zgodne");	
 	 	WriteTextXY(0,1,"z nastawami     ");
		};
	if (klaw_mat_menu==2)
		{
		WriteTextXY(0,0,"Rozladowanie    ");	
 	 	WriteTextXY(0,1,"zgodne z nast.  ");
		};
	if (klaw_mat_menu==3)
		{
		WriteTextXY(0,0,"Sterowanie      ");	
 	 	WriteTextXY(0,1,"manualne        ");
		};
	if (klaw_mat_menu==4)
		{
		WriteTextXY(0,0,"Tryb            ");	
 	 	WriteTextXY(0,1,"regeneracji     ");
		};
	if (klaw_mat_menu==5)
		{
		WriteTextXY(0,0,"Ustawienia      ");	
 	 	WriteTextXY(0,1,"graniczne U,I   ");
		};
	if (klaw_mat_menu>=6) resecik();


	return;
	};





void zadania_klaw (void)
{
//******************************************************************************************
//***********                              *************************************************
//***********  PROCEDURA ADOWANIA BATERII *************************************************
//***********                              *************************************************
//******************************************************************************************

if(klaw_mat_menu==1 && key_active==1)			//
	{
	//wywietlenie aktualnych nastaw

	if(dod_zm==1)  // pierwsze uruchomienie
		{
		WriteTextXY(0,0,"Umax=            ");	
 	 	WriteTextXY(0,1,"Imax=            ");
		Potencjometr=Nap_max;	
		GotoXY(5,0);	
		binbcd2 (Potencjometr);
		LcdWrite(v3);LcdWrite(v4);LcdWrite(',');LcdWrite(v5);LcdWrite('V');

		Potencjometr=Prad_max;
		GotoXY(5,1);	
		binbcd2 (Potencjometr);
		LcdWrite(v2);LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);LcdWrite('m');LcdWrite('A');
		delay(3000);
		WriteTextXY(0,0,"                 ");	
 	 	WriteTextXY(0,1,"                 ");
		
		// ustawienie przekanika na tryb adowania
		PORTC=0; //wyczenie prdu podczas przeczania
		delay(10);
		PORTB= PORTB & 0b10111111;
		ak_smiec4=0;
		dod_zm=2;
		zeg_wibro2=0;
		C_small=0;C_large=0;C_large2=0;

		Umax=Nap_max*10;
		
		usr_u=Prad_max*0.15;
		Imin=usr_u;
		ink_eep=0;				//zerowanie wskanika do zmiennych eeprom
		aktywacjaEEP=1;			//odblokowanie zapisu danych do eepromu
		};

	Ubat=Pomiar_U_ACC();
	Ibat=Pomiar_I_ACC();
	if (Ubat>50)	// sprawdzenie czy jest bateria
		{
		if((Ubat<Umax) & (Ubat>Umin))	// napicie baterii jest w zaoonym przedziale
			{
			while ((Ibat<Prad_max) & (dod_zm==2))
				{

				if (Ubat>Umax) 	goto etykieta2;
				ak_smiec2=PINC+5;
				if(ak_smiec2>=255)ak_smiec2=255;
				ak_smiec4=ak_smiec2;
				PORTC= ak_smiec4;
				delay(150);
				Ubat=Pomiar_U_ACC();// pomiar parametrw
				Ibat=Pomiar_I_ACC();
				
				GotoXY(0,1);	// wywietlenie 
				binbcd2 (Ibat);
				LcdWrite('I');LcdWrite('=');LcdWrite(v2);LcdWrite(',');LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);

				GotoXY(9,1);	// wywietlenie wyniku 
				binbcd2 (Ubat);
				LcdWrite('U');LcdWrite('=');LcdWrite(v2);LcdWrite(v3);LcdWrite(',');LcdWrite(v4);LcdWrite(v5);
				};
			
			while ((Ibat> (Prad_max+5)) & (dod_zm==2))
				{
				ak_smiec4=PINC;
				ak_smiec4--;
				PORTC= ak_smiec4;
				delay(150); 		//stabilizacja pracy baterii
				Ibat=Pomiar_I_ACC();
				};

			


etykieta2:
			dod_zm=3;
			
			Ubat=Pomiar_U_ACC();// pomiar parametrw	
			while (Ubat>Umax)
				{
				ak_smiec4=PINC;
				ak_smiec4--;
				PORTC= ak_smiec4;
				delay(100);
		
				Ibat=Pomiar_I_ACC();
				Ubat=Pomiar_U_ACC();// pomiar parametrw
				if(Ibat<Imin)// koniec adowania
					{
					WriteTextXY(0,1,"Koniec           ");
					delay(1000);
					PORTC=0; //wyczenie prdu podczas przeczania
					key_active=0;
					goto koniec1;
					};

				};
							
			}	
		else	// bateria jest poza zakresem
			{
			Ubat=Pomiar_U_ACC();// pomiar parametrw
			if(Ubat>=Umax) goto etykieta2;
			if(Ubat<Umin)	
				{
				WriteTextXY(0,0,"Bateria poza     ");	
	 			WriteTextXY(0,1,"zakresem         ");
				GotoXY(9,1);	// wywietlenie wyniku temperatury
				binbcd2 (Ubat);
				LcdWrite(v2);LcdWrite(v3);LcdWrite(',');LcdWrite(v4);LcdWrite(v5);LcdWrite('V');
				delay(6000);
				PORTC=0; //wyczenie prdu podczas przeczania
				key_active=0;
				};
			
			};		

		}
		else //wyryto  brak baterii
			{
			WriteTextXY(0,0,"Brak baterii     ");	
 			WriteTextXY(0,1,"                 ");
			delay(3000);
			PORTC=0; //wyczenie prdu podczas przeczania
			key_active=0;
			};


	Ubat=Pomiar_U_ACC();// pomiar parametrw
	Ibat=Pomiar_I_ACC();
	GotoXY(0,1);	// wywietlenie 
	binbcd2 (Ibat);
	LcdWrite('I');LcdWrite('=');LcdWrite(v2);LcdWrite(',');LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);

	
	GotoXY(9,1);	// wywietlenie wyniku temperatury
	binbcd2 (Ubat);
	LcdWrite('U');LcdWrite('=');LcdWrite(v2);LcdWrite(v3);LcdWrite(',');LcdWrite(v4);LcdWrite(v5);
 

	// pomiar pojemnoci
	while (zeg_wibro2 >= 1)
		{
		zeg_wibro2--;
		usr_u=Ibat*2.777;
		ak_smiec2=usr_u;
		C_small=C_small+ak_smiec2;
		if (C_small>=10000)
			{
			C_small=C_small-10000;
			C_large++;
			if (C_large>=10000){C_large=C_large-10000;C_large2++;};
			};

		ak_smiec3=C_large2;
		GotoXY(0,0);	// wywietlenie wyniku temperatury
		binbcd2 (ak_smiec3);
		LcdWrite('C');LcdWrite('=');LcdWrite(v5);
	
		ak_smiec3=C_large;
		GotoXY(3,0);	// wywietlenie wyniku temperatury
		binbcd2 (ak_smiec3);
		LcdWrite(v2);LcdWrite(',');LcdWrite(v3);LcdWrite(v4);LcdWrite('A');LcdWrite('h');
		}; 

	
	Pomiar_temperatury(); // pomiar temperatury

	koniec1:
	delay(1);
	};
//******************************************************************************************
//**********************                                  **********************************
//**********************  PROCEDURA ROZADOWANIA BATERII  **********************************
//**********************                                  **********************************
//******************************************************************************************
if(klaw_mat_menu==2 && key_active==1)			//
	{
	//wywietlenie aktualnych nastaw

	if(dod_zm==1)  // pierwsze uruchomienie
		{
		WriteTextXY(0,0,"Umin=            ");	
 	 	WriteTextXY(0,1,"Imax_roz=        ");
		Potencjometr=Nap_min;	
		GotoXY(6,0);	
		binbcd2 (Potencjometr);
		LcdWrite(v3);LcdWrite(v4);LcdWrite(',');LcdWrite(v5);LcdWrite('V');

		Potencjometr=Prad_max_roz;
		GotoXY(10,1);	
		binbcd2 (Potencjometr);
		LcdWrite(v2);LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);LcdWrite('m');LcdWrite('A');
		delay(2000);
		WriteTextXY(0,0,"                 ");	
 	 	WriteTextXY(0,1,"                 ");
		
		// ustawienie przekanika na tryb rozadowania
		PORTC=0; //wyczenie prdu podczas przeczania
		delay(10);
		PORTB= PORTB | 0b01000000;
		ak_smiec4=0;
		dod_zm=2;
		zeg_wibro2=0;
		C_small=0;C_large=0;C_large2=0;

		Umin=Nap_min*10;
		usr_u=Prad_max_roz/11.71;
		PORTC=usr_u;
		ink_eep=0;				//zerowanie wskanika do zmiennych eeprom
		aktywacjaEEP=1;			//odblokowanie zapisu danych do eepromu
		};




	Ubat=Pomiar_U_ACC();
	Ibat=Pomiar_I_ACC();
	
	if(Ubat < Umin)	//napicie spada pniej minimalnego
		{
		if(Ibat<(Prad_max_roz*0.15))	// niskie napicie i may prd --> trzeba koczy
			{PORTC=0;key_active=0;}
		else	//prd mona zmniejszy
			{
			ak_smiec4=PINC;
			ak_smiec4--;
			PORTC= ak_smiec4;
			}
		};	

	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	Ibat=Pomiar_I_ACC();
	GotoXY(0,1);	// wywietlenie 
	binbcd2 (Ibat);
	LcdWrite('I');LcdWrite('=');LcdWrite(v2);LcdWrite(',');LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	Ubat=Pomiar_U_ACC();// pomiar parametrw
	GotoXY(9,1);	// wywietlenie wyniku temperatury
	binbcd2 (Ubat);
	LcdWrite('U');LcdWrite('=');LcdWrite(v2);LcdWrite(v3);LcdWrite(',');LcdWrite(v4);LcdWrite(v5);
 	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
									// pomiar pojemnoci
	while (zeg_wibro2 >= 1)
		{
		zeg_wibro2--;
		usr_u=Ibat*2.777;
		ak_smiec2=usr_u;
		C_small=C_small+ak_smiec2;
		if (C_small>=10000)
			{
			C_small=C_small-10000;
			C_large++;
			if (C_large>=10000){C_large=C_large-10000;C_large2++;};
			};

		ak_smiec3=C_large2;
		GotoXY(0,0);	// wywietlenie wyniku temperatury
		binbcd2 (ak_smiec3);
		LcdWrite('C');LcdWrite('=');LcdWrite(v5);
	
		ak_smiec3=C_large;
		GotoXY(3,0);	// wywietlenie wyniku temperatury
		binbcd2 (ak_smiec3);
		LcdWrite(v2);LcdWrite(',');LcdWrite(v3);LcdWrite(v4);LcdWrite('A');LcdWrite('h');
		}; 

	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	Pomiar_temperatury(); // pomiar temperatury
		

	};




//******************************************************************************************
//******************************************************************************************
//*********************                       **********************************************
//*********************  STEROWANIE MANUALNE  **********************************************
//*********************                       **********************************************
//******************************************************************************************
//******************************************************************************************
if(klaw_mat_menu==3 && key_active==1)			// sterowanie manualne
	{

	if(dod_zm==1)
		{
		WriteTextXY(0,0,"  Tryb          ");	
 	 	WriteTextXY(0,1,"  ladowania     ");
		};
	if(dod_zm==2)
		{
		WriteTextXY(0,0,"  Tryb          ");	
 	 	WriteTextXY(0,1,"  rozladowania  ");
		};
	if(dod_zm==3)
		{
		WriteTextXY(0,0,"  EXIT          ");	
 	 	WriteTextXY(0,1,"                ");
		};

	if(dod_zm2==100 && dod_zm==1)
		{
		PORTC=0; //wyczenie prdu podczas przeczania
		delay(10);
		PORTB= PORTB & 0b10111111;
		delay(10);
		dod_zm=4;
		dod_zm2=0;
	    WriteTextXY(0,0,"                ");	
 	 	WriteTextXY(0,1,"                ");
		C_small=0;C_large=0;C_large2=0;
		ink_eep=0;				//zerowanie wskanika do zmiennych eeprom
		aktywacjaEEP=1;			//odblokowanie zapisu danych do eepromu
		};
	if(dod_zm2==100 && dod_zm==2)
		{
		PORTC=0;	//wyczenie prdu podczas przeczania
		delay(10);
		PORTB= PORTB | 0b01000000;
		delay(10);
		dod_zm=4;
		dod_zm2=0;
		WriteTextXY(0,0,"                ");	
 	 	WriteTextXY(0,1,"                ");
		C_small=0;C_large=0;C_large2=0;
		ink_eep=0;				//zerowanie wskanika do zmiennych eeprom
		aktywacjaEEP=1;			//odblokowanie zapisu danych do eepromu
		};
	if(dod_zm2==100 && dod_zm==3)
		{
		resecik();WriteTextXY(0,1,"     OK         ");delay(1000);
		};
	
	if(dod_zm>=5)dod_zm=1;	





//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSs
	if(dod_zm==4)
		{
		//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
											// obliczanie PRDU 
		Potencjometr=Pomiar_potencjometru();
		Potencjometr=Potencjometr>>2;
		PORTC	= Potencjometr;
		Potencjometr=Pomiar_I_ACC();
		GotoXY(0,1);	// wywietlenie 
		binbcd2 (Potencjometr);
		LcdWrite('I');LcdWrite('=');LcdWrite(v2);LcdWrite(',');LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);
		//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
				
											// obliczanie napicia 
		Ubat=Pomiar_U_ACC();
		if(Ubat>1880)Ubat=0;
		GotoXY(9,1);	// wywietlenie wyniku 
		binbcd2 (Potencjometr);
		LcdWrite('U');LcdWrite('=');LcdWrite(v2);LcdWrite(v3);LcdWrite(',');LcdWrite(v4);LcdWrite(v5);
		//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
											// pomiar pojemnoci
		Ibat=Pomiar_I_ACC();
		while (zeg_wibro2 >= 1)
			{
			zeg_wibro2--;
			usr_u=Ibat*2.777;
			ak_smiec2=usr_u;
			C_small=C_small+ak_smiec2;
			if (C_small>=10000)
				{
				C_small=C_small-10000;
				C_large++;
				if (C_large>=10000){C_large=C_large-10000;C_large2++;};
				};

			ak_smiec3=C_large2;
			GotoXY(0,0);	
			binbcd2 (ak_smiec3);
			LcdWrite('C');LcdWrite('=');LcdWrite(v5);
	
			ak_smiec3=C_large;
			GotoXY(3,0);	
			binbcd2 (ak_smiec3);
			LcdWrite(v2);LcdWrite(',');LcdWrite(v3);LcdWrite(v4);LcdWrite('A');LcdWrite('h');
			};  
		//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	    
	    Pomiar_temperatury();// pomiar temperatury
		};
	
	};


//******************************************************************************************
//******************************************************************************************
//***************************                            ***********************************
//***************************     TRYB REGENERACJI       ***********************************
//***************************                            ***********************************
//******************************************************************************************
//******************************************************************************************
if(klaw_mat_menu==4 && key_active==1)			
	{
	if(dod_zm==1)  // pierwsze uruchomienie
		{
		WriteTextXY(0,0,"Umax=            ");	
 	 	WriteTextXY(0,1,"Imax=            ");
		Potencjometr=Nap_max;	
		GotoXY(5,0);	
		binbcd2 (Potencjometr);
		LcdWrite(v3);LcdWrite(v4);LcdWrite(',');LcdWrite(v5);LcdWrite('V');

		Potencjometr=Prad_max;
		GotoXY(5,1);	
		binbcd2 (Potencjometr);
		LcdWrite(v2);LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);LcdWrite('m');LcdWrite('A');
		delay(2000);
		WriteTextXY(0,0,"Regen.           ");	
 	 	WriteTextXY(0,1,"                 ");
		
		// ustawienie przekanika na tryb adowania
		PORTC=0; //wyczenie prdu podczas przeczania
		delay(10);
		PORTB= PORTB & 0b10111111;
		ak_smiec4=0;
		dod_zm=2;
		Umax=Nap_max*10;

		usr_u=Prad_max/11.71;
		PORTC=usr_u;
		ink_eep=0;				//zerowanie wskanika do zmiennych eeprom
		aktywacjaEEP=1;			//odblokowanie zapisu danych do eepromu
		};
	usr_u=Prad_max/11.71;
	PORTC=usr_u;
	delay(100);
	PORTC=0;
	delay(100);


	Ubat=Pomiar_U_ACC();				// pomiar parametrw
	if (Ubat > Umax) 
		{
		key_active=0;		// wyczenie procedury po osigniciu zadanego napicia
		WriteTextXY(0,1,"           Koniec");

		};
	GotoXY(0,1);						// wywietlenie wyniku temperatury
	binbcd2 (Ubat);
	LcdWrite('U');LcdWrite('=');LcdWrite(v2);LcdWrite(v3);LcdWrite(',');LcdWrite(v4);LcdWrite(v5);

	Pomiar_temperatury(); // pomiar temperatury

	};



//******************************************************************************************
//******************************************************************************************
//***************************                            ***********************************
//***************************   NASTAWY PRDW I NAPI  ***********************************
//***************************                            ***********************************
//******************************************************************************************
//******************************************************************************************
if(klaw_mat_menu==5 && key_active==1)			
	{
	if(dod_zm==1)
		{
		WriteTextXY(0,0,"Odczyt ustawien ");	
 	 	WriteTextXY(0,1,"                ");
		};
	if(dod_zm==2)
		{
		WriteTextXY(0,0,"Ustawienie      ");	
 	 	WriteTextXY(0,1,"I max ladowania ");
		};
	if(dod_zm==3)
		{
		WriteTextXY(0,0,"Ustawienie      ");	
 	 	WriteTextXY(0,1,"U max ladowania ");
		};
	if(dod_zm==4)
		{
		WriteTextXY(0,0,"Ustawienie      ");	
 	 	WriteTextXY(0,1,"I max rozlad.   ");
		};
	
	if(dod_zm==5)
		{
		WriteTextXY(0,0,"Ustawienie      ");	
 	 	WriteTextXY(0,1,"U min rozlad    ");
		};
	if(dod_zm==6)
		{
		WriteTextXY(0,0,"EXIT            ");	
 	 	WriteTextXY(0,1,"                ");
		};
		
	if(dod_zm>=7)
		{
		dod_zm=1;
		};

	if(dod_zm2==100)			// tutaj nastpuje wybr podmenu
		{
		key_active=0;
		if      (dod_zm == 1){WYB_menu_nastaw=1;dod_zm2=0;dod_zm=1;}//uruchomienie funkcji w pliku nastawy.h
		else if (dod_zm == 2){WYB_menu_nastaw=2;dod_zm2=0;dod_zm=1;}//uruchomienie funkcji w pliku nastawy.h
		else if (dod_zm == 3){WYB_menu_nastaw=3;dod_zm2=0;dod_zm=1;}//uruchomienie funkcji w pliku nastawy.h
		else if (dod_zm == 4){WYB_menu_nastaw=4;dod_zm2=0;dod_zm=1;}//uruchomienie funkcji w pliku nastawy.h
		else if (dod_zm == 5){WYB_menu_nastaw=5;dod_zm2=0;dod_zm=1;}//uruchomienie funkcji w pliku nastawy.h
		else if (dod_zm == 6){resecik();WriteTextXY(0,1,"    OK          ");delay(1000);}
		};

	};


//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
};







void resecik (void)
{
l_menu_wys_mat=0xfe;	//zezwolenie na wywietlenie menu gwnego na LCD
klaw_mat_menu=1;
WYB_menu_nastaw=0;
dod_zm2=0;
dod_zm=0;
key_active=0;			//klawisz nie 
PORTC=0;				//wyczenie prdu 
crc_count=0;			// reset licznika bdw od temperatury
ink_eep=0;				//zerowanie wskanika do zmiennych eeprom
aktywacjaEEP=0;			// zablokowanie wysyania danych do epromu
};








//###################################################################################
//###################################################################################
void Pomiar_temperatury(void)
	{
	
	czek=OW_Reset_R();	//reset pulse
	if (czek==1)
		{
		//SN_DS1_7=0;
		Nadaj_OW(0x55);		//MATCH ROOM  --adresowanie 
		Nadaj_OW(SN_DS1_1);Nadaj_OW(SN_DS1_2);Nadaj_OW(SN_DS1_3);Nadaj_OW(SN_DS1_4);
		Nadaj_OW(SN_DS1_5);Nadaj_OW(SN_DS1_6);Nadaj_OW(SN_DS1_7);Nadaj_OW(SN_DS1_8);
			
		Nadaj_OW(0x44);		//rozpocznij pomiar temperatury
		delay_u(750);
	
		czek=OW_Reset_R();	//reset pulse
		Nadaj_OW(0x55);		//MATCH ROOM  --adresowanie 
		Nadaj_OW(SN_DS1_1);Nadaj_OW(SN_DS1_2);Nadaj_OW(SN_DS1_3);Nadaj_OW(SN_DS1_4);
		Nadaj_OW(SN_DS1_5);Nadaj_OW(SN_DS1_6);Nadaj_OW(SN_DS1_7);Nadaj_OW(SN_DS1_8);
		
		Nadaj_OW(0xBE);		//czytaj pami danych 
		
		temp1=read_byte_OW_R();	temp2=read_byte_OW_R();	rrom3=read_byte_OW_R();	rrom4=read_byte_OW_R();
		rrom5=read_byte_OW_R();	rrom6=read_byte_OW_R();	rrom7=read_byte_OW_R();	rrom8=read_byte_OW_R();
		rrom9=read_byte_OW_R();
		
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		//obliczenie sumy kontrolnej
		crc_check = CRC_OW(temp1, 0);
		crc_check = CRC_OW(temp2, crc_check);
		crc_check = CRC_OW(rrom3, crc_check);
		crc_check = CRC_OW(rrom4, crc_check);
		crc_check = CRC_OW(rrom5, crc_check);
		crc_check = CRC_OW(rrom6, crc_check);
		crc_check = CRC_OW(rrom7, crc_check);
		crc_check = CRC_OW(rrom8, crc_check);
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		
		if(crc_check==rrom9)		// test crc wypad pozytywnie
			{
			if(temp2>=248)		// temperatura ujemna
				{
				temp=(65536-(temp1+(temp2*256)))*10;
				temp_f=temp;
				temp=0;
				temp=temp_f/16;
				GotoXY(10,0);LcdWrite('-');
				}
			else			// temperatura dodatnia
				{
				temp=((temp1+(temp2*256))*10)/16;
				GotoXY(10,0);LcdWrite('+');	
				};
		 
			GotoXY(11,0);	// wywietlenie wyniku temperatury
		    binbcd2 (temp);
		    LcdWrite(v2);LcdWrite(v3);LcdWrite(v4);LcdWrite(',');LcdWrite(v5);
			};
		};
	};
//###################################################################################
//###################################################################################



//###################################################################################
//###################################################################################
int Pomiar_temperatury2(void)
	{
	czek=OW_Reset_R();	//reset pulse
	if (czek==1)
		{
		//SN_DS1_7=0;
		Nadaj_OW(0x55);		//MATCH ROOM  --adresowanie 
		Nadaj_OW(SN_DS1_1);Nadaj_OW(SN_DS1_2);Nadaj_OW(SN_DS1_3);Nadaj_OW(SN_DS1_4);
		Nadaj_OW(SN_DS1_5);Nadaj_OW(SN_DS1_6);Nadaj_OW(SN_DS1_7);Nadaj_OW(SN_DS1_8);
			
		Nadaj_OW(0x44);		//rozpocznij pomiar temperatury
		delay_u(750);
	
		czek=OW_Reset_R();	//reset pulse
		Nadaj_OW(0x55);		//MATCH ROOM  --adresowanie 
		Nadaj_OW(SN_DS1_1);Nadaj_OW(SN_DS1_2);Nadaj_OW(SN_DS1_3);Nadaj_OW(SN_DS1_4);
		Nadaj_OW(SN_DS1_5);Nadaj_OW(SN_DS1_6);Nadaj_OW(SN_DS1_7);Nadaj_OW(SN_DS1_8);
		
		Nadaj_OW(0xBE);		//czytaj pami danych 
		
		temp1=read_byte_OW_R();	temp2=read_byte_OW_R();	rrom3=read_byte_OW_R();	rrom4=read_byte_OW_R();
		rrom5=read_byte_OW_R();	rrom6=read_byte_OW_R();	rrom7=read_byte_OW_R();	rrom8=read_byte_OW_R();
		rrom9=read_byte_OW_R();
		
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		//obliczenie sumy kontrolnej
		crc_check = CRC_OW(temp1, 0);
		crc_check = CRC_OW(temp2, crc_check);
		crc_check = CRC_OW(rrom3, crc_check);
		crc_check = CRC_OW(rrom4, crc_check);
		crc_check = CRC_OW(rrom5, crc_check);
		crc_check = CRC_OW(rrom6, crc_check);
		crc_check = CRC_OW(rrom7, crc_check);
		crc_check = CRC_OW(rrom8, crc_check);
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		
		if(crc_check==rrom9)		// test crc wypad pozytywnie
			{
			if(temp2>=248)		// temperatura ujemna
				{
				temp=(65536-(temp1+(temp2*256)))*10;
				temp_f=temp;
				temp=0;
				temp=temp_f/16;
				}
			else			// temperatura dodatnia
				{
				temp=((temp1+(temp2*256))*10)/16;
				};
			crc_count=0;
			ak_smiec=temp;
			old_temp=temp;
			return(ak_smiec);
			}
			else					//test crc nieprawidowy
				{
				crc_count++;			
				if (crc_count <= 5) return(old_temp);
				else	return(2003);
				};
		}
		else
		{
		return(2001);
		};
	
	crc_count++;			
	if (crc_count <= 5) return(old_temp);
	else	return(2002);
	};
//###################################################################################
//###################################################################################










