
void odczyt_klaw (void);
void binbcd2 (int zl2);
char EX_OR(char A, char B);
char CRC_OW(char Rej_testowy, char Rej_zmienny);
int Pomiar_ADC(char kanal);
void Sortuj_szybko(int lewy, int prawy);
int Pomiar_U_ACC(void);
int Pomiar_I_ACC(void);
int Pomiar_potencjometru(void);
void zapise_int_do_epp(int address, int zmienna);
char EEPROM_read(unsigned int uiAddress);
void EEPROM_write(unsigned int uiAddress, char ucData);
void termostat(void);
void zapis_eeprom (void);




void odczyt_klaw (void)
{

ak_smiec = PIND;	// klawisz nadrzedny
ak_smiec = ak_smiec & 0b10000000; 
if(ak_smiec == 0) 
	{
	if(key_active==0)
		{
		delay(key_del);
		klaw_mat_menu++;
		dod_zm=0;
		if(klaw_mat_menu==(il_ekranow+1))klaw_mat_menu=1;
		l_menu_wys_mat= 0xfe;
		}
		else //bdny wybr funkcji
		{
		key_active=0;		
		l_menu_wys_mat= 0xfe;
		PORTC=0;
		};
	};

ak_smiec = PIND;		// klawisz podrzedny
ak_smiec = ak_smiec & 0b01000000; 
if(ak_smiec == 0)   {
					delay(key_del);
				    ak_smiec = PIND;
					ak_smiec = ak_smiec & 0b01000000;
					if(ak_smiec == 0)dod_zm2=100;		//DUGO WCINITY KLAWISZ
						else dod_zm++;
					key_active=1;
					};

ak_smiec = PIND;
ak_smiec = ak_smiec & 0b11000000; 
if(ak_smiec == 0) WDTCR=0b00001000;			//Uruchomienie WDT w celu resetu aplikacji



return;
};



int Pomiar_ADC(char kanal)
	{
		
	//**********  zmienn do przetwornika ADC ***************
	//******************************************************
	char  pomiar_d=0, pamiar_maly=0;
	int ADC_pom=0;	
	//******************************************************
	//******************************************************

		switch (kanal)
				{
				case 0:	{ADMUX=ADMUX & 0b11111000;break;};
				case 1:	{ADMUX=ADMUX & 0b11111000;ADMUX=ADMUX | 0b00000001;break;};
				case 2:	{ADMUX=ADMUX & 0b11111000;ADMUX=ADMUX | 0b00000010;break;};
				case 3:	{ADMUX=ADMUX & 0b11111000;ADMUX=ADMUX | 0b00000011;break;};
				case 4:	{ADMUX=ADMUX & 0b11111000;ADMUX=ADMUX | 0b00000100;break;};
				case 5:	{ADMUX=ADMUX & 0b11111000;ADMUX=ADMUX | 0b00000101;break;};
				case 6:	{ADMUX=ADMUX & 0b11111000;ADMUX=ADMUX | 0b00000110;break;};
				case 7:	{ADMUX=ADMUX & 0b11111000;ADMUX=ADMUX | 0b00000111;break;};
				default:{break;};
				};
		
		//zerowanie zmiennych pomocniczych	i rejestrw	
		ADC_pom=0;ADCL=0;ADCH=0;
			
		
		ADMUX=ADMUX & 0b11000111;		//  |7,6  |		5			|  4 ,3,2,1,0   |
		ADMUX=ADMUX | 0b11000000;		//	|U odn|10 bit do lewej	|Kana pomiarowy|
		
		//ADCSRA=   |      7    |       6       |     5    		|    4     			|  		 3 				| 2 | 1 |0 |
		//		=   |   ADEN    |     ADSC		|   ADFR		|	ADIF			| 		ADIE			|ADPS2-0   |
		//			|aktywny ADC|star konwersji |Free running	|flaga ze jest  	|uaktywnieni przerwania |podzielnik|
		//			|	1-akt	|	1-akt		|1-akt			|	1-akt			|	1-akt				|		   |		
		ADCSRA =ADCSRA | 0b11000111;   // start konwersji z podziaem f przez 128 
		ADCSRA =ADCSRA & 0b11111111;   // start konwersji z podziaem f przez 128


			asm("nop");	asm("nop");	asm("nop");
			while (ADIF==0) 
				{
				asm("nop");
				};
		
	
			delay(3);
			//zapisanie wynikw
			pamiar_maly=ADCL;
			pomiar_d=ADCH;
			
			
			
			ADCL=0;ADCH=0;					//zerowanie rejestrw
			ADCSRA =ADCSRA & 0b10101111;   // wyczenie odczytu
		
		
		ADC_pom=(256*pomiar_d)+pamiar_maly;
		
		return(ADC_pom);
	};



//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%% Procedura sortowania szybkiego %%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


void Sortuj_szybko(int lewy, int prawy)
{
  int i,j,piwot,k;

  i = (lewy + prawy) / 2;
  piwot = d[i]; d[i] = d[prawy];
  for(j = i = lewy; i < prawy; i++)
  if(d[i] < piwot)
  {
  	k=d[i];	d[i]=d[j];	d[j]=k; //swap
    j++;
  }
  d[prawy] = d[j]; d[j] = piwot;
  if(lewy < j - 1)  Sortuj_szybko(lewy, j - 1);
  if(j + 1 < prawy) Sortuj_szybko(j + 1, prawy);
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


void binbcd2 (int zl2)
	{
		//	Radosaw Rochowski 24.12.2006
		//  Funkcja zamieniajca kad binarny na bcd 16 bitw maks 65536
		//	potrzebne zmienne
		//	unsigned int zl=0,zk=0; 
		//  unsigned char v1,v2,v3;
		v1=0;v2=0;v3=0;	v4=0;v5=0;				//zerowanie zmiennych

		zk2=zl2;
		zl2=zl2/10000;							// dziele przez 10000 i zostawiam reszte za pomoc %
		v1=zl2%10;
		v1 = v1 + 0x30;							// zamiana do kodu ascii
		zl2=zk2;
		zl2=zl2/1000;							// dziele przez 1000 i zostawiam reszte za pomoc %
		v2=zl2%10;
		v2 = v2 + 0x30;							// zamiana do kodu ascii
		zl2=zk2;
		zl2=zl2/100;							// dziele przez sto i zostawiam reszte za pomoc %
		v3=zl2%10;
		v3 = v3 + 0x30;							// zamiana do kodu ascii
		zl2=zk2;
		zl2=zl2/10;								// dziele przez sto i zostawiam reszte za pomoc %
		v4=zl2%10;
		v4 = v4 + 0x30;
		zl2=zk2;
		v5=zk2%10;								// dziele przez sto i zostawiam reszte za pomoc %	
		v5 = v5 + 0x30;
		
	};

char CRC_OW(char Rej_testowy, char Rej_zmienny)
	{
	char alfa1,beta1,beta2,beta3,wynik,akul,pomoc = 0;	
	char i;	
		
	for(i=1;i<=8;i++)
		{
		alfa1=Rej_testowy & 0x01;
		Rej_testowy=Rej_testowy>>1;	
		beta1=Rej_zmienny & 0x01;
		beta2=(Rej_zmienny & 0x08)>>3;
		beta3=(Rej_zmienny & 0x10)>>4;
		
		wynik=Rej_zmienny>>1;
		wynik=wynik & 0B01110011;
		
		akul=EX_OR(alfa1,beta1);				
		if(akul==1)	wynik=wynik | 0x80;		//wpis na 8 pozycje rejestru
			else wynik=wynik & 0x7F;
		
		pomoc=EX_OR(akul,beta3);
		if(pomoc==1)	wynik=wynik | 0x08;		//wpis na 4 pozycje rejestru
			else wynik=wynik & 0xF7;
		
		pomoc=EX_OR(akul,beta2);
		if(pomoc==1)	wynik=wynik | 0x04;		//wpis na 3 pozycje rejestru
			else wynik=wynik & 0xFB;	
		Rej_zmienny=wynik;	
		}
		return (Rej_zmienny);
	}
char EX_OR(char A, char B)
	{
		if(A==B)	return 0;
		return 1;
	}


int Pomiar_U_ACC(void)
	{
	int pom_u_plus=0,pom_u_minus=0;


	for(q1=0;q1<N;q1++)	d[q1]=Pomiar_ADC(1);Sortuj_szybko(0,N - 1);Potencjometr=d[H];	//dczytanie nastawy potencjometru
	pom_u_plus=Potencjometr;
	
	usr_u=Potencjometr*2.806; //staa dzielnika napcia
    Potencjometr=usr_u;
	pom_u_plus=Potencjometr;

	for(q1=0;q1<N;q1++)	d[q1]=Pomiar_ADC(7);Sortuj_szybko(0,N - 1);Potencjometr=d[H];	//dczytanie nastawy potencjometru
	pom_u_minus=Potencjometr;

	usr_u=Potencjometr*2.675; //staa dzielnika napcia
    Potencjometr=usr_u;
	pom_u_minus=Potencjometr;
	Potencjometr=pom_u_plus-pom_u_minus;
	return (Potencjometr);
	};

int Pomiar_I_ACC(void)
	{
	for(q1=0;q1<N;q1++)	d[q1]=Pomiar_ADC(6);Sortuj_szybko(0,N - 1);Potencjometr=d[H];	
	usr_u=Potencjometr*4.92;
	Potencjometr=usr_u;
	return (Potencjometr);
	};

int Pomiar_potencjometru(void)
	{
	for(q1=0;q1<N;q1++)	d[q1]=Pomiar_ADC(2);Sortuj_szybko(0,N - 1);Potencjometr=d[H];	//dczytanie nastawy potencjometru
	usr_u=Potencjometr*1.00195;
	Potencjometr=usr_u;
	if(Potencjometr>=1023)Potencjometr=1023;
	return (Potencjometr);
	};


void zapise_int_do_epp(int addressx, int zmienna)
			{
			//void EEPROM_write(unsigned int uiAddress, char ucData);
			char sr5,sr6;
			ak_smiec=zmienna >> 8;
			sr5=ak_smiec;
			ak_smiec2=zmienna & 0x00ff;
			sr6=ak_smiec2;
			EEPROM_write(addressx,sr6);
			EEPROM_write(++addressx,sr5);
			};



void EEPROM_write(unsigned int uiAddress, char ucData) 
	{ 
	/* Wait for completion of previous write */ 
	while(EECR & (1<<EEWE)); 
	/* Set up address and data registers */ 
	EEAR = uiAddress; 
	EEDR = ucData; 
	/* Write logical one to EEMWE */ 
	EECR |= (1<<EEMWE); 
	/* Start eeprom write by setting EEWE */ 
	EECR |= (1<<EEWE); 
	} 
char EEPROM_read(unsigned int uiAddress)
	{
	/* Wait for completion of previous write */
	while(EECR & (1<<EEWE));
	/* Set up address register */
	EEAR = uiAddress;
	/* Start eeprom read by writing EERE */
	EECR |= (1<<EERE);
	/* Return data from data register */
	return EEDR;
	}



//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
void termostat(void)
{
ak_smiec=Pomiar_temperatury2();
if( ak_smiec >= (Temp_set+delta_t)) //za gorco wcz chodzenie
	{
	PORTG	= PORTG | 0b00000001;
	//tutaj wcz wentylator
	};

if(ak_smiec <= (Temp_set-delta_t)) //chodny wycz chodzenie
	{
	PORTG	= PORTG & 0b11111110;
	//tutaj wycz wentylator
	};

return;
}
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


void zapis_eeprom (void)
{
if(aktywacjaEEP==1)	
	{
	if (czas_eeprom >= czas_eeprom_ustaw)	// to wykonuje gdy upynie odpowiedni czas
		{
		czas_eeprom=0;		//zerowanie czasu wywoania	


		ak_smiec=Ibat;
		ak_smiec=ak_smiec & 0b0000000011111111;
		ak_smiec4=ak_smiec;;
		EEPROM_write((bank_eeprom+ink_eep),ak_smiec4);
		if (bank_zakres <= ink_eep) ink_eep=bank_zakres ;		// zabezpieczenie przed przepelneniem bufora danych
		else ink_eep++;
	
	
		ak_smiec=Ibat;
		ak_smiec=ak_smiec & 0b1111111100000000;
		ak_smiec=ak_smiec>>8;
		ak_smiec4=ak_smiec;;
		EEPROM_write((bank_eeprom+ink_eep),ak_smiec4);
		if (bank_zakres <= ink_eep) ink_eep=bank_zakres ;		// zabezpieczenie przed przepelneniem bufora danych
		else ink_eep++;
	
		ak_smiec=Ubat;
		ak_smiec=ak_smiec & 0b0000000011111111;
		ak_smiec4=ak_smiec;;
		EEPROM_write((bank_eeprom+ink_eep),ak_smiec4);
		if (bank_zakres <= ink_eep) ink_eep=bank_zakres ;		// zabezpieczenie przed przepelneniem bufora danych
		else ink_eep++;
	
	
		ak_smiec=Ubat;
		ak_smiec=ak_smiec & 0b1111111100000000;
		ak_smiec=ak_smiec>>8;
		ak_smiec4=ak_smiec;;
		EEPROM_write((bank_eeprom+ink_eep),ak_smiec4);
		if (bank_zakres <= ink_eep) ink_eep=bank_zakres ;		// zabezpieczenie przed przepelneniem bufora danych
		else ink_eep++;
		
		};
	};
}




